## udev udev — libudev context |

## Functions

struct udev * | udev_ref ()
struct udev * | udev_unref ()
struct udev * | udev_new ()
void | udev_set_log_fn ()
int | udev_get_log_priority ()
void | udev_set_log_priority ()
void * | udev_get_userdata ()
void | udev_set_userdata ()

## Types and Values

struct | udev

## Description

The context contains the default values read from the udev config file, and is passed to all library operations.

## Functions

### udev_ref ()

    struct udev *
    udev_ref (struct udev *udev);

Take a reference of the udev library context.

#### Parameters

udev | udev library context |

#### Returns

the passed udev library context

### udev_unref ()

    struct udev *
    udev_unref (struct udev *udev);

Drop a reference of the udev library context. If the refcount reaches zero, the resources of the context will be released.

#### Parameters

udev | udev library context |

#### Returns

the passed udev library context if it has still an active reference, or NULL otherwise.

### udev_new ()

    struct udev *
    udev_new (void);

Create udev library context. This reads the udev configuration file, and fills in the default values.

The initial refcount is 1, and needs to be decremented to release the resources of the udev library context.

#### Returns

a new udev library context

### udev_set_log_fn ()

    void
    udev_set_log_fn (struct udev *udev,
                     void (*log_fn) (struct udev *udev, int priority, const char *file, int line, const char *fn, const char *format, va_list args));

The built-in logging writes to stderr. It can be overridden by a custom function, to plug log messages into the users' logging functionality.

#### Parameters

udev | udev library context |
log_fn | function to be called for logging messages |

### udev_get_log_priority ()

    int
    udev_get_log_priority (struct udev *udev);

The initial logging priority is read from the udev config file at startup.

#### Parameters

udev | udev library context |

#### Returns

the current logging priority

### udev_set_log_priority ()

    void
    udev_set_log_priority (struct udev *udev,
                           int priority);

Set the current logging priority. The value controls which messages are logged.

#### Parameters

udev | udev library context |
priority | the new logging priority |

### udev_get_userdata ()

    void *
    udev_get_userdata (struct udev *udev);

Retrieve stored data pointer from library context. This might be useful to access from callbacks like a custom logging function.

#### Parameters

udev | udev library context |

#### Returns

stored userdata

### udev_set_userdata ()

    void
    udev_set_userdata (struct udev *udev,
                       void *userdata);

Store custom `userdata` in the library context.

#### Parameters

udev | udev library context |
userdata | data pointer |

## Types and Values

### struct udev

    struct udev;

Opaque object representing the library context.